import { LRLanguage, LanguageSupport, LanguageDescription } from '@codemirror/language';
import { parseMixed } from '@lezer/common';
import { ExternalTokenizer, LRParser, ContextTracker } from '@lezer/lr';
import { Tag, styleTags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const PieDiagram = 1,
  MindmapDiagram = 2,
  empty = 5;

const skipCodePoints = [-1, 9, 10, 13, 32, 9];
const diagramMap = {
    mindmap: MindmapDiagram,
    pie: PieDiagram,
};
const diagrams = Object.keys(diagramMap);
const longestTextLength = diagrams.reduce((a, b) => {
    return a.length > b.length ? a : b;
}).length;
const diagramText = new ExternalTokenizer((input) => {
    if (skipCodePoints.includes(input.next))
        return;
    let tokens = '';
    for (let i = 0; i < longestTextLength; i++) {
        const codePoint = input.peek(i);
        if (skipCodePoints.includes(codePoint))
            break;
        tokens += String.fromCodePoint(codePoint);
    }
    while (input.next !== -1) {
        input.advance();
    }
    if (diagrams.includes(tokens))
        input.acceptToken(diagramMap[tokens]);
    else
        input.acceptToken(empty);
    return;
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser$2 = LRParser.deserialize({
  version: 14,
  states: "[OQOPOOQOOOOO",
  stateData: "]~OPPOQPOTPO~O",
  goto: "QPP",
  nodeNames: "⚠ PieDiagram MindmapDiagram MermaidDiagram",
  maxTerm: 5,
  skippedNodes: [0],
  repeatNodeCount: 0,
  tokenData: "RORO",
  tokenizers: [diagramText],
  topRules: {"MermaidDiagram":[0,3]},
  tokenPrec: 0
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const indent = 30,
  LineText1 = 1,
  LineText2 = 2,
  LineText3 = 3,
  LineText4 = 4,
  LineText5 = 5,
  newline$2 = 31,
  newlineEmpty = 32;

const LineTextTokens = [LineText1, LineText2, LineText3, LineText4, LineText5];
const newline$1 = 10, carriageReturn = 13, space = 32, tab = 9, hash = 35, colon = 58, parenL = 40, parenR = 41, bracketL = 91, bracketR = 93, braceL = 123, braceR = 125;
const newlines = new ExternalTokenizer((input, _stack) => {
    if (input.next < 0)
        return;
    else {
        input.advance();
        let spaces = 0;
        while (input.next == space || input.next == tab) {
            input.advance();
            spaces++;
        }
        let empty = input.next == newline$1 ||
            input.next == carriageReturn ||
            input.next == hash;
        input.acceptToken(empty ? newlineEmpty : newline$2, -spaces);
    }
}, { contextual: true, fallback: true });
const lineTextType = new ExternalTokenizer((input, stack) => {
    let chars = 0;
    while (input.next > -1 && input.next !== newline$1) {
        if (input.next === colon)
            return;
        if (input.next === parenL ||
            input.next === bracketL ||
            input.next === braceL) {
            if (chars > 0) {
                input.acceptToken(stack.context.lineType);
                return;
            }
            else
                return;
        }
        if ((input.next === parenR ||
            input.next === bracketR ||
            input.next === braceR) &&
            chars > 0) {
            input.acceptToken(stack.context.lineType);
            return;
        }
        input.advance();
        chars++;
    }
    input.acceptToken(stack.context.lineType);
});
const indentation = new ExternalTokenizer((input, _stack) => {
    let prev = input.peek(-1);
    if (prev == newline$1 || prev == carriageReturn) {
        while (true) {
            if (input.next == space)
                ;
            else if (input.next == tab)
                ;
            else
                break;
            input.advance();
        }
        if (input.next != newline$1 &&
            input.next != carriageReturn &&
            input.next != hash) {
            input.acceptToken(indent);
        }
    }
});
const indentTracker = {
    lineType: LineText1,
};
const countIndent = (space) => {
    let depth = 0;
    for (let i = 0; i < space.length; i++)
        depth += space.charCodeAt(i) == tab ? 8 - (depth % 8) : 1;
    return depth;
};
const getLineType = (depth) => {
    return LineTextTokens[depth % 5];
};
const trackIndent = new ContextTracker({
    start: indentTracker,
    shift(context, term, stack, input) {
        if (term === indent) {
            const depth = countIndent(input.read(input.pos, stack.pos));
            context.lineType = getLineType(depth);
        }
        return context;
    },
});

const mindmapTags = {
    diagramName: Tag.define(),
    lineText1: Tag.define(),
    lineText2: Tag.define(),
    lineText3: Tag.define(),
    lineText4: Tag.define(),
    lineText5: Tag.define(),
};
const pieTags = {
    diagramName: Tag.define(),
    lineComment: Tag.define(),
    number: Tag.define(),
    showData: Tag.define(),
    string: Tag.define(),
    title: Tag.define(),
    titleText: Tag.define(),
};

const mindmapHighlighting = styleTags({
    DiagramName: mindmapTags.diagramName,
    LineText1: mindmapTags.lineText1,
    LineText2: mindmapTags.lineText2,
    LineText3: mindmapTags.lineText3,
    LineText4: mindmapTags.lineText4,
    LineText5: mindmapTags.lineText5,
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_word$1 = {__proto__:null,mindmap:72, icon:76};
const parser$1 = LRParser.deserialize({
  version: 14,
  states: "&fOYQ[OOOOQW'#Cw'#CwQbQ[OOQgQ[OOOOQW'#Cc'#CcOOQW-E6u-E6uOlQ]O'#CdOOQW'#Cx'#CxQgQ[OOO!]Q^O,59OOOQW-E6v-E6vOOQW'#DR'#DRO!vQ[O'#CgO!{Q^O'#CjO!{Q^O'#CmO!{Q^O'#CnO!{Q^O'#CqO!{Q^O'#CrO!{Q^O'#CsO!{Q^O'#CvOOQW'#DU'#DUO#^Q[O1G.jOOQW1G.j1G.jO#hQ[O,59ROOQW'#Ch'#ChOOQW,59U,59UO#mQ[O,59XO#rQ[O,59YO#wQ[O,59]O#|Q[O,59^O$RQ[O,59_O$WQ[O,59bOOQW7+$U7+$UO!{Q^O1G.mOOQW1G.s1G.sOOQW1G.t1G.tOOQW1G.w1G.wOOQW1G.x1G.xOOQW1G.y1G.yOOQW1G.|1G.|O$]Q[O7+$XOOQW<<Gs<<Gs",
  stateData: "$b~OrOSpOS~OoPOtSO~OoPO~OoUO~OnXOmWXoWX~OXbO]_O`^OcaOd`OicO~OPZOQZORZOSZOTZOY[Ow]O~PwOvhO~OPZOQZORZOSZOTZO~OmWioWi~PwO]qO~O_rO~OXsO~OctO~OduO~O]vO~OhwO~OXyO~O",
  goto: "#[yPPPPPPPz}PP!R!UP!RPP!X!XPP!X!X!XPP!X!]!cPPPPPPPP!iPP#URROTVRWRfXRg[TdXeQQORTQQWRRYWQeXQi]Qj^Qk_Ql`QmaQnbQocRxqQfXRpe",
  nodeNames: "⚠ LineText1 LineText2 LineText3 LineText4 LineText5 MindmapDiagram DiagramName Line ) :: IconLine Icon ( ClassLine ] [ Square RoundedSquare )) (( Circle Bang Cloud }} {{ Hexagon",
  maxTerm: 40,
  context: trackIndent,
  nodeProps: [
    ["openedBy", 9,"(",15,"[",19,"((",24,"{{"],
    ["closedBy", 13,")",16,"]",20,"))",25,"}}"]
  ],
  propSources: [mindmapHighlighting],
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "$b~R]XYz[]zpqzxy!fyz!s![!]#Q!c!}#e!}#O#p#O#P!]#P#Q#u#T#o#e#o#p#z#q#r$V~!PSr~XYz[]zpqz#O#P!]~!`QYZz]^z~!kP]~xy!n~!sOd~~!xPX~yz!{~#QOc~~#TP![!]#W~#]PY~![!]#`~#eOw~~#jQs~!c!}#e#T#o#e~#uO`~~#zO_~~#}P#o#p$Q~$VOi~~$YP#q#r$]~$bOh~",
  tokenizers: [indentation, lineTextType, 0, newlines],
  topRules: {"MindmapDiagram":[0,6]},
  specialized: [{term: 35, get: value => spec_word$1[value] || -1}],
  tokenPrec: 0
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const TitleText = 1;

const newline = 10;
const titleText = new ExternalTokenizer((input) => {
    let { next } = input;
    if (next === newline) {
        input.acceptToken(TitleText);
        return;
    }
    while (input.next !== newline && input.next !== -1) {
        input.advance();
    }
    input.acceptToken(TitleText);
});

const pieHighlighting = styleTags({
    DiagramName: pieTags.diagramName,
    LineComment: pieTags.lineComment,
    Number: pieTags.number,
    ShowData: pieTags.showData,
    String: pieTags.string,
    Title: pieTags.title,
    TitleText: pieTags.titleText,
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_word = {__proto__:null,pie:36, showData:38, title:40};
const parser = LRParser.deserialize({
  version: 14,
  states: "#xO]QQOOObQQO'#ClOOQO'#Cf'#CfQ]QQOOOOQO'#C`'#C`OsQQO'#CcOOQO'#Cg'#CgOxQQO,59WO!TQQO,59WO!cQRO,59WOOQO'#Ca'#CaOOQP'#Cb'#CbOOQO-E6d-E6dO!qQQO,58}OOQO-E6e-E6eO!vQQO1G.rO#RQRO1G.rO!vQQO1G.rOOQO1G.i1G.iO#^QQO7+$^O#^QQO7+$^O#iQQO<<Gx",
  stateData: "#t~O^OSQOS_OS~ObSO~OWTOcYOdZO[`Xb`X~Oe]O~OWTO[`ab`a~OWTOdZO[`ab`a~OPaOWTO[`ab`a~OXbO~OWTO[`ib`i~OPcO[`ib`i~OWTO[`qb`q~OWTO[`yb`y~O",
  goto: "!iaPPPPbfioPPz!QPPPP!eTPORRWPQXPR`WcUPVWX_acdeQROR[RQVPW^V_deS_WXQdaRecTQOR",
  nodeNames: "⚠ TitleText LineComment PieDiagram DiagramName ShowData Title Dataset String Number",
  maxTerm: 21,
  propSources: [pieHighlighting],
  skippedNodes: [0,2],
  repeatNodeCount: 2,
  tokenData: "%[~RYXYqYZ!P]^qpqqrs!Uuv#r!Q![$a![!]$z!c!}%P#T#o%P~vR^~XYq]^qpqq~!UO_~~!XVOr!Urs!ns#O!U#O#P!s#P;'S!U;'S;=`#l<%lO!U~!sOW~~!vRO;'S!U;'S;=`#P;=`O!U~#SWOr!Urs!ns#O!U#O#P!s#P;'S!U;'S;=`#l;=`<%l!U<%lO!U~#oP;=`<%l!U~#uPuv#x~#}SQ~OY#xZ;'S#x;'S;=`$Z<%lO#x~$^P;=`<%l#x~$fQX~!O!P$l!Q![$a~$oP!Q![$r~$wPX~!Q![$r~%POe~~%UQa~!c!}%P#T#o%P",
  tokenizers: [titleText, 0],
  topRules: {"PieDiagram":[0,3]},
  specialized: [{term: 17, get: value => spec_word[value] || -1}],
  tokenPrec: 0
});

const mermaidLanguage = LRLanguage.define({
    name: 'mermaid',
    parser: parser$2.configure({
        wrap: parseMixed((node) => {
            if (node.name === 'MindmapDiagram')
                return { parser: parser$1 };
            if (node.name === 'PieDiagram')
                return { parser: parser };
            return null;
        }),
    }),
});
const mindmapLanguage = LRLanguage.define({
    name: 'mindmap',
    parser: parser$1,
});
const pieLanguage = LRLanguage.define({
    name: 'pie',
    parser: parser,
});

function mermaid() {
    return new LanguageSupport(mermaidLanguage);
}
function mindmap() {
    return new LanguageSupport(mindmapLanguage);
}
function pie() {
    return new LanguageSupport(pieLanguage);
}

const mermaidLanguageDescription = LanguageDescription.of({
    name: 'mermaid',
    load: async () => {
        return mermaid();
    },
});
const mindmapLanguageDescription = LanguageDescription.of({
    name: 'mindmap',
    load: async () => {
        return mindmap();
    },
});
const pieLanguageDescription = LanguageDescription.of({
    name: 'pie',
    load: async () => {
        return pie();
    },
});

export { mermaid, mermaidLanguage, mermaidLanguageDescription, mindmap, mindmapLanguage, mindmapLanguageDescription, mindmapTags, pie, pieLanguage, pieLanguageDescription, pieTags };
